<template>
  <div class="camerChannel">
    <div class="deviceBox">
      <div class="deviceBtnGroup">
        <h4>用户管理</h4>
        <el-button type="primary" icon="el-icon-plus" @click="handleAdddevice()"
          >新增</el-button
        >
      </div>
      <div class="deviceTable">
        <el-table
          ref="multipleTable"
          :data="deviceTableData"
          stripe
          tooltip-effect="dark"
          style="width: 100%"
          height="calc(100% - 40px)"
          @selection-change="handleSelectionChange"
          @row-click="handleRowClick"
        >
          <!-- <el-table-column type="index" width="55"> </el-table-column>
          <el-table-column type="selection" width="55"> </el-table-column> -->
          <el-table-column
            label="用户名"
            show-overflow-tooltip
            prop="userName"
          ></el-table-column>
          <el-table-column label="角色" show-overflow-tooltip prop="role">
            <template slot-scope="scope">{{
              scope.row.role == 1 ? "管理员" : "用户"
            }}</template>
          </el-table-column>
          <el-table-column
            label="创建时间"
            show-overflow-tooltip
            prop="createTime"
          >
            <template slot-scope="scope">{{
              $moment(scope.row.createTime).format("yy-MM-DD HH:mm:ss")
            }}</template>
          </el-table-column>
          <el-table-column fixed="right" label="操作" width="200">
            <template slot-scope="scope">
              <el-button
                @click.native.stop="handleResive(scope.row)"
                type="text"
                >修改</el-button
              >
              <el-button
                type="text"
                class="deleteText"
                @click.native.stop="handleDelete(scope.row)"
                >删除</el-button
              >
            </template>
          </el-table-column>
        </el-table>
        <div class="pageNation">
          <el-pagination
            @current-change="handleCurrentChange"
            @size-change="handleSizeChange"
            :current-page="page"
            :page-size="pageSize"
            layout="sizes, prev, pager, next, jumper,total"
            :total="total"
            background
          >
          </el-pagination>
        </div>
      </div>
    </div>
    <!-- 新增 -->
    <addUser :title="title" ref="adduserref"></addUser>
  </div>
</template>
<script>
import addUser from "./components/addUser.vue";
import { getUserList, delUserApi } from "@/utils/api/index";

export default {
  components: {
    addUser,
  },
  data() {
    return {
      title: "", //弹窗标题
      deviceTableData: [],
      //multipleSelection: [], //获取当前选中
      page: 1, // 当前页数
      pageSize: 20, // 每页数量
      total: 0, //总条数
    };
  },
  created() {
    this.deviceList();
  },
  methods: {
    //获取线路列表数据
    deviceList() {
      getUserList({
        pageindex: this.page,
        pagesize: this.pageSize,
      })
        .then((res) => {
          this.deviceTableData = res.data.list;
          this.total = res.data.total;
        })
        .catch((err) => {});
    },
    //点击行选中
    handleRowClick(row, column, event) {
      this.$refs.multipleTable.toggleRowSelection(row);
    },
    //获取选中的行
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },

    // 新建
    handleAdddevice() {
      this.title = "新增";
      this.$refs.adduserref.display();
      this.$refs.adduserref.getdataform(null);
    },

    //修改
    handleResive(data) {
      this.title = "修改";
      this.$refs.adduserref.display();
      this.$refs.adduserref.getdataform(data);
    },

    //删除数据
    handleDelete(data) {
      this.$confirm("确定要删除记录吗,同时删除关联关系?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          delUserApi({ uid: data.userId }).then((res) => {
            if (res.code == 200) {
              this.$message.success("删除成功");
              this.deviceList(); //刷新
            } else {
              this.$message.error(res.msg);
            }
          });
        })
        .catch(() => {
          this.$message({
            showClose: true,
            type: "info",
            message: "已取消删除",
          });
        });
    },
    //点击分页
    handleCurrentChange(val) {
      this.page = val;
      this.deviceList();
    },
    //每页条数
    handleSizeChange(val) {
      this.pageSize = val;
      this.deviceList();
    },
  },
};
</script>
<style lang="less">
.camerChannel {
  width: calc(100% - 32px);
  height: calc(100% - 32px);
  padding: 16px 16px;
  background: @color-white;

  .deviceBox {
    border: 1px solid #dddddd;
    height: calc(100% - 32px);
    padding: 16px;
    border-radius: 4px;
  }
  .deviceBtnGroup {
    display: flex;
    justify-content: space-between;
    align-items: center;
  }

  .deviceTable {
    margin-top: 16px;
    height: calc(100% - 48px);
    //background: #fcc;
  }
}
</style>
